scala.swing

# RefBuffer

#### abstract class RefBuffer[A <: AnyRef] extends Buffer[A] with SingleRefCollection[A]

Self Type
  RefBuffer[A]
Source
  Publisher.scala

Linear Supertypes
SingleRefCollection[A], Buffer[A], BufferLike[A, Buffer[A]], Subtractable[A, Buffer[A]], Scriptable[A], Shrinkable[A], Growable[A], Clearable, collection.mutable.Seq[A], SeqLike[A, Buffer[A]], collection.mutable.Cloneable[Buffer[A]], Cloneable, java.lang.Cloneable, collection.Seq[A], SeqLike[A, Buffer[A]], GenSeq[A], GenSeqLike[A, Buffer[A]], PartialFunction[Int, A], (Int) ⇒ A, collection.mutable.Iterable[A], collection.Iterable[A], IterableLike[A, Buffer[A]], Equals, GenIterable[A], GenIterableLike[A, Buffer[A]], collection.mutable.Traversable[A], Mutable, collection.Traversable[A], GenTraversable[A], GenericTraversableTemplate[A, Buffer], TraversableLike[A, Buffer[A]], GenTraversableLike[A, Buffer[A]], Parallelizable[A, ParSeq[A]], collection.TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, Buffer[A]], HasNewBuilder[A, scala.collection.mutable.Buffer[A] @scala.annotation.unchecked.uncheckedVariance], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. RefBuffer
2. SingleRefCollection
3. Buffer
4. BufferLike
5. Subtractable
6. Scriptable
7. Shrinkable
8. Growable
9. Clearable
10. Seq
11. SeqLike
12. Cloneable
13. Cloneable
14. Cloneable
15. Seq
16. SeqLike
17. GenSeq
18. GenSeqLike
19. PartialFunction
20. Function1
21. Iterable
22. Iterable
23. IterableLike
24. Equals
25. GenIterable
26. GenIterableLike
27. Traversable
28. Mutable
29. Traversable
30. GenTraversable
31. GenericTraversableTemplate
32. TraversableLike
33. GenTraversableLike
34. Parallelizable
35. TraversableOnce
36. GenTraversableOnce
37. FilterMonadic
38. HasNewBuilder
39. AnyRef
40. Any

Implicitly

1. by traversable2ops
2. by MonadOps
3. by any2stringadd
4. by any2stringfmt
5. by any2ArrowAssoc
6. by any2Ensuring
7. by alternateImplicit

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new RefBuffer()

### Type Members

1. #### trait Ref[+A <: AnyRef] extends Reference[A]

   Definition Classes
     SingleRefCollection

2. #### type Self = Buffer[A]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

3. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Abstract Value Members

1. #### abstract def Ref(a: A): Ref[A]

   Attributes
     protected[this]
   Definition Classes
     SingleRefCollection

2. #### abstract def insertAll(n: Int, elems: collection.Traversable[A]): Unit

   Inserts new elements at a given index into this buffer.

   Inserts new elements at a given index into this buffer.

   n

     the index where new elements are inserted.

   elems

     the traversable collection containing the elements to insert.

   Definition Classes
     BufferLike
   Exceptions thrown
     IndexOutOfBoundsException

     if the index `n` is not in the valid range `0 <= n <= length`.

3. #### abstract val underlying: Buffer[Reference[A]]

   Attributes
     protected
   Definition Classes
     RefBuffer → SingleRefCollection

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ++(xs: GenTraversableOnce[A]): Buffer[A]

   Creates a new collection containing both the elements of this collection and the provided traversable object.

   Creates a new collection containing both the elements of this collection and the provided traversable object.

   xs

     the traversable object.

   returns

     a new collection consisting of all the elements of this collection and `xs`.

   Definition Classes
     BufferLike
   Annotations
     @migration
   Migration

     (Changed in version 2.8.0) `++` creates a new buffer. Use `++=` to add an element from this buffer and return that buffer itself.

6. #### def ++[B](that: GenTraversableOnce[B]): Buffer[B]

   [use case] Returns a new buffer containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new buffer containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the buffer is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = LinkedList(1)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val b = LinkedList(2)
       b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val c = a ++ b
       c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

       scala> val d = LinkedList('a')
       d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

       scala> val e = c ++ d
       e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new buffer which contains all elements of this buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

7. #### def ++:[B >: A, That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B](that: collection.TraversableOnce[B]): Buffer[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new buffer which contains all elements of this buffer followed by all elements of `that`.

   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: A, That](that: collection.TraversableOnce[B])(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

9. #### def ++=(xs: collection.TraversableOnce[A]): RefBuffer.this.type

   Appends all elements produced by a TraversableOnce to this buffer.

   Appends all elements produced by a TraversableOnce to this buffer.

   xs

     the TraversableOnce producing the elements to append.

   returns

     the buffer itself.

   Definition Classes
     Growable

10. #### def ++=:(xs: collection.TraversableOnce[A]): RefBuffer.this.type

    Prepends elements to this buffer.

    Prepends elements to this buffer.

    xs

      the TraversableOnce containing the elements to prepend.

    returns

      the buffer itself.

    Definition Classes
      BufferLike

11. #### def +:(elem: A): Buffer[A]

    [use case] A copy of the buffer with an element prepended.

    [use case]

    A copy of the buffer with an element prepended.

    Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

    Also, the original buffer is not modified, so you will want to capture the result.

    Example:

        scala> val x = LinkedList(1)
        x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

        scala> val y = 2 +: x
        y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

        scala> println(x)
        LinkedList(1)

    elem

      the prepended element

    returns

      a new buffer consisting of `elem` followed by all elements of this buffer.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

12. #### def +=(el: A): RefBuffer.this.type

    Appends a single element to this buffer.

    Appends a single element to this buffer.

    returns

      the buffer itself

    Definition Classes
      RefBuffer → BufferLike → Growable

13. #### def +=(elem1: A, elem2: A, elems: A*): RefBuffer.this.type

    Appends two or more elements to this buffer.

    Appends two or more elements to this buffer.

    elem1

      the first element to append.

    elem2

      the second element to append.

    elems

      the remaining elements to append.

    returns

      the buffer itself

    Definition Classes
      Growable

14. #### def +=:(el: A): RefBuffer.this.type

    Prepends a single element to this buffer.

    Prepends a single element to this buffer.

    returns

      the buffer itself.

    Definition Classes
      RefBuffer → BufferLike

15. #### def -(elem1: A, elem2: A, elems: A*): Buffer[A]

    Creates a new collection with all the elements of this collection except the two or more specified elements.

    Creates a new collection with all the elements of this collection except the two or more specified elements.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new collection consisting of all the elements of this collection except `elem1`, `elem2` and those in `elems`.

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new buffer. Use `-=` to remove an element from this buffer and return that buffer itself.

16. #### def -(elem: A): Buffer[A]

    Creates a new collection with all the elements of this collection except `elem`.

    Creates a new collection with all the elements of this collection except `elem`.

    elem

      the element to remove.

    returns

      a new collection consisting of all the elements of this collection except `elem`.

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `-` creates a new buffer. Use `-=` to remove an element from this buffer and return that buffer itself.

17. #### def --(xs: GenTraversableOnce[A]): Buffer[A]

    Creates a new collection with all the elements of this collection except those provided by the specified traversable object.

    Creates a new collection with all the elements of this collection except those provided by the specified traversable object.

    xs

      the traversable object.

    returns

      a new collection with all the elements of this collection except those in `xs`

    Definition Classes
      BufferLike → Subtractable
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `--` creates a new buffer. Use `--=` to remove an element from this buffer and return that buffer itself.

18. #### def --=(xs: collection.TraversableOnce[A]): RefBuffer.this.type

    Removes all elements produced by an iterator from this buffer.

    Removes all elements produced by an iterator from this buffer.

    xs

      the iterator producing the elements to remove.

    returns

      the buffer itself

    Definition Classes
      Shrinkable

19. #### def -=(x: A): RefBuffer.this.type

    Removes a single element from this buffer, at its first occurrence.

    Removes a single element from this buffer, at its first occurrence. If the buffer does not contain that element, it is unchanged.

    x

      the element to remove.

    returns

      the buffer itself

    Definition Classes
      BufferLike → Shrinkable

20. #### def -=(elem1: A, elem2: A, elems: A*): RefBuffer.this.type

    Removes two or more elements from this buffer.

    Removes two or more elements from this buffer.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      the buffer itself

    Definition Classes
      Shrinkable

21. #### def ->[B](y: B): (RefBuffer[A], B)

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to ArrowAssoc[RefBuffer[A]] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
    Annotations
      @inline()

22. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this buffer, going left to right.

    Applies a binary operator to a start value and all elements of this buffer, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (5 /: a)(_+_)
        b: Int = 15

        scala> val c = (5 /: a)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this buffer, going left to right with the start value `z` on the left:

          op(...op(op(z, x_1), x_2), ..., x_n)

      where `x1, ..., xn` are the elements of this buffer.

    Definition Classes
      TraversableOnce → GenTraversableOnce

23. #### def :+(elem: A): Buffer[A]

    [use case] A copy of this buffer with an element appended.

    [use case]

    A copy of this buffer with an element appended.

    A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

    Example:

        scala> import scala.collection.mutable.LinkedList
        import scala.collection.mutable.LinkedList

        scala> val a = LinkedList(1)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

        scala> val b = a :+ 2
        b: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

        scala> println(a)
        LinkedList(1)

    elem

      the appended element

    returns

      a new buffer consisting of all elements of this buffer followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

24. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this buffer and a start value, going right to left.

    Applies a binary operator to all elements of this buffer and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this buffer, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this buffer.

    Definition Classes
      TraversableOnce → GenTraversableOnce

25. #### def <<(cmd: Message[A]): Unit

    Send a message to this scriptable object.

    Send a message to this scriptable object.

    cmd

      the message to send.

    Definition Classes
      BufferLike → Scriptable

26. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

27. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

28. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this buffer to a string builder.

    Appends all elements of this buffer to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this buffer without any separator string.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

29. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this buffer to a string builder using a separator string.

    Appends all elements of this buffer to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this buffer, separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

30. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this buffer to a string builder using start, end, and separator strings.

    Appends all elements of this buffer to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this buffer are separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, "LinkedList(", ", ", ")")
        res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

31. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

32. #### def andThen[C](k: (A) ⇒ C): PartialFunction[Int, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

33. #### def append(elems: A*): Unit

    Appends the given elements to this buffer.

    Appends the given elements to this buffer.

    elems

      the elements to append.

    Definition Classes
      BufferLike

34. #### def appendAll(xs: collection.TraversableOnce[A]): Unit

    Appends the elements contained in a traversable object to this buffer.

    Appends the elements contained in a traversable object to this buffer.

    xs

      the traversable object containing the elements to append.

    Definition Classes
      BufferLike

35. #### def apply(n: Int): A

    Selects an element by its index in the buffer.

    Selects an element by its index in the buffer.

    Example:

        scala> val x = LinkedList(1, 2, 3, 4, 5)
        x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

        scala> x(3)
        res1: Int = 4

    returns

      the element of this buffer at index `idx`, where `0` indicates the first element.

    Definition Classes
      RefBuffer → BufferLike → SeqLike → GenSeqLike → Function1
    Exceptions thrown
      `IndexOutOfBoundsException`

      if `idx` does not satisfy `0 <= idx < length`.

36. #### def applyOrElse[A1 <: Int, B1 >: A](x: A1, default: (A1) ⇒ B1): B1

    Applies this partial function to the given argument when it is contained in the function domain.

    Applies this partial function to the given argument when it is contained in the function domain. Applies fallback function where this partial function is not defined.

    Note that expression `pf.applyOrElse(x, default)` is equivalent to

        if(pf isDefinedAt x) pf(x) else default(x)

    except that `applyOrElse` method can be implemented more efficiently. For all partial function literals compiler generates `applyOrElse` implementation which avoids double evaluation of pattern matchers and guards. This makes `applyOrElse` the basis for the efficient implementation for many operations and scenarios, such as:

    - combining partial functions into `orElse`/`andThen` chains does not lead to excessive `apply`/`isDefinedAt` evaluation
    - `lift` and `unlift` do not evaluate source functions twice on each invocation
    - `runWith` allows efficient imperative-style combining of partial functions with conditionally applied actions

    For non-literal partial function classes with nontrivial `isDefinedAt` method it is recommended to override `applyOrElse` with custom implementation that avoids double `isDefinedAt` evaluation. This may result in better performance and more predictable behavior w.r.t. side effects.

    x

      the function argument

    default

      the fallback function

    returns

      the result of this function or fallback function application.

    Definition Classes
      PartialFunction
    Since

      2.10

37. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

38. #### def asParIterable: ParIterable[A]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

39. #### def asParSeq: ParSeq[A]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

40. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this buffer should be compared

    returns

      `true`, if this buffer can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

41. #### def clear(): Unit

    Clears the buffer's contents.

    Clears the buffer's contents. After this operation, the buffer is empty.

    Definition Classes
      RefBuffer → BufferLike → Growable → Clearable

42. #### def clone(): Buffer[A]

    Return a clone of this buffer.

    Return a clone of this buffer.

    returns

      a `Buffer` with the same elements.

    Definition Classes
      BufferLike → Cloneable → AnyRef

43. #### def collect[B](pf: PartialFunction[A, B]): Buffer[B]

    [use case] Builds a new collection by applying a partial function to all elements of this buffer on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this buffer on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the buffer.

    returns

      a new buffer resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike
    Full Signature

    #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

44. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the buffer for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the buffer for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

45. #### def combinations(n: Int): collection.Iterator[Buffer[A]]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this buffer.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

46. #### def companion: GenericCompanion[Buffer]

    The factory companion object that builds instances of class `Buffer`.

    The factory companion object that builds instances of class `Buffer`. (or its `Iterable` superclass where class `Buffer` is not a `Seq`.)

    Definition Classes
      Buffer → Seq → Seq → GenSeq → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

47. #### def compose[A](g: (A) ⇒ Int): (A) ⇒ A

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1
    Annotations
      @unspecialized()

48. #### def contains(elem: Any): Boolean

    Tests whether this buffer contains a given value as an element.

    Tests whether this buffer contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this buffer has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

49. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this buffer contains a given sequence as a slice.

    Tests whether this buffer contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this buffer contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

50. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this buffer to an array.

    [use case]

    Copies elements of this buffer to an array. Fills the given array `xs` with at most `len` elements of this buffer, starting at position `start`. Copying will stop once either the end of the current buffer is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

51. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this buffer to an array.

    [use case]

    Copies values of this buffer to an array. Fills the given array `xs` with values of this buffer. Copying will stop once either the end of the current buffer is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B]): Unit

52. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this buffer to an array.

    [use case]

    Copies values of this buffer to an array. Fills the given array `xs` with values of this buffer, beginning at index `start`. Copying will stop once either the end of the current buffer is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

53. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this buffer to a buffer.

    Copies all elements of this buffer to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

54. #### def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this buffer relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this buffer relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this buffer and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

55. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the buffer which satisfy a predicate.

    Counts the number of elements in the buffer which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

56. #### def diff(that: collection.Seq[A]): Buffer[A]

    [use case] Computes the multiset difference between this buffer and another sequence.

    [use case]

    Computes the multiset difference between this buffer and another sequence.

    that

      the sequence of elements to remove

    returns

      a new buffer which contains all elements of this buffer except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def diff[B >: A](that: GenSeq[B]): Buffer[A]

57. #### def distinct: Buffer[A]

    Builds a new buffer from this buffer without any duplicate elements.

    Builds a new buffer from this buffer without any duplicate elements.

    returns

      A new buffer which contains the first occurrence of every element of this buffer.

    Definition Classes
      SeqLike → GenSeqLike

58. #### def drop(n: Int): Buffer[A]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this buffer.

    returns

      a buffer consisting of all elements of this buffer except the first `n` ones, or else the empty buffer, if this buffer has less than `n` elements.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike

59. #### def dropRight(n: Int): Buffer[A]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a buffer consisting of all elements of this buffer except the last `n` ones, or else the empty buffer, if this buffer has less than `n` elements.

    Definition Classes
      IterableLike

60. #### def dropWhile(p: (A) ⇒ Boolean): Buffer[A]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    returns

      the longest suffix of this buffer whose first element does not satisfy the predicate `p`.

    Definition Classes
      TraversableLike → GenTraversableLike

61. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this buffer ends with the given sequence.

    Tests whether this buffer ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this buffer has `that` as a suffix, `false` otherwise.

    Definition Classes
      SeqLike → GenSeqLike

62. #### def ensuring(cond: (RefBuffer[A]) ⇒ Boolean, msg: ⇒ Any): RefBuffer[A]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to Ensuring[RefBuffer[A]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

63. #### def ensuring(cond: (RefBuffer[A]) ⇒ Boolean): RefBuffer[A]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to Ensuring[RefBuffer[A]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

64. #### def ensuring(cond: Boolean, msg: ⇒ Any): RefBuffer[A]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to Ensuring[RefBuffer[A]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

65. #### def ensuring(cond: Boolean): RefBuffer[A]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to Ensuring[RefBuffer[A]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

66. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

67. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → Any

68. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this buffer.

    Tests whether a predicate holds for some of the elements of this buffer.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this buffer, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

69. #### def filter(p: (A) ⇒ Boolean): Buffer[A]

    Selects all elements of this buffer which satisfy a predicate.

    Selects all elements of this buffer which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new buffer consisting of all elements of this buffer that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

70. #### def filterNot(p: (A) ⇒ Boolean): Buffer[A]

    Selects all elements of this buffer which do not satisfy a predicate.

    Selects all elements of this buffer which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new buffer consisting of all elements of this buffer that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

71. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

72. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the buffer satisfying a predicate, if any.

    Finds the first element of the buffer satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the buffer that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

73. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): Buffer[B]

    [use case] Builds a new collection by applying a function to all elements of this buffer and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this buffer and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of buffer. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be a an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new buffer resulting from applying the given collection-valued function `f` to each element of this buffer and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

74. #### def flatten[B]: Buffer[B]

    [use case] Converts this buffer of traversable collections into a buffer formed by the elements of these traversable collections.

    [use case]

    Converts this buffer of traversable collections into a buffer formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of buffer. For example:

        val xs = List(Set(1, 2, 3), Set(1, 2, 3))
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(List(1, 2, 3), List(3, 2, 1))
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new buffer resulting from concatenating all element buffers.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Buffer[B]

75. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this buffer using the specified associative binary operator.

    Folds the elements of this buffer using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

76. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this buffer, going left to right.

    Applies a binary operator to a start value and all elements of this buffer, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this buffer, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this buffer.

    Definition Classes
      TraversableOnce → GenTraversableOnce

77. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this buffer and a start value, going right to left.

    Applies a binary operator to all elements of this buffer and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this buffer, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this buffer.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

78. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this buffer.

    Tests whether a predicate holds for all elements of this buffer.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this buffer, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

79. #### def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this buffer.

    [use case]

    Applies a function `f` to all elements of this buffer.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Full Signature

    #### def foreach[U](f: (A) ⇒ U): Unit

80. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

81. #### def genericBuilder[B]: Builder[B, Buffer[B]]

    The generic builder that builds instances of `Buffer` at arbitrary element types.

    The generic builder that builds instances of `Buffer` at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

82. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

83. #### def groupBy[K](f: (A) ⇒ K): Map[K, Buffer[A]]

    Partitions this buffer into a map of buffers according to some discriminator function.

    Partitions this buffer into a map of buffers according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new buffer.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to buffers such that the following invariant holds:

          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a buffer of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

84. #### def grouped(size: Int): collection.Iterator[Buffer[A]]

    Partitions elements in fixed size buffers.

    Partitions elements in fixed size buffers.

    size

      the number of elements per group

    returns

      An iterator producing buffers of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

85. #### def hasDefiniteSize: Boolean

    Tests whether this buffer is known to have a finite size.

    Tests whether this buffer is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

86. #### def hashCode(): Int

    Hashcodes for `Buffer` produce a value from the hashcodes of all the elements of the buffer.

    Hashcodes for `Buffer` produce a value from the hashcodes of all the elements of the buffer.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → Any

87. #### def head: A

    Selects the first element of this buffer.

    Selects the first element of this buffer.

    returns

      the first element of this buffer.

    Definition Classes
      IterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the buffer is empty.

88. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this buffer if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

89. #### def ifParSeq[R](isbody: (ParSeq[A]) ⇒ R): (TraversableOps[A])#Otherwise[R]

    Implicit information
      This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

90. #### def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this buffer after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this buffer after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this buffer that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: A](elem: B, from: Int): Int

91. #### def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this buffer.

    [use case]

    Finds index of first occurrence of some value in this buffer.

    elem

      the element value to search for.

    returns

      the index of the first element of this buffer that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: A](elem: B): Int

92. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this buffer contains a given sequence as a slice.

    Finds first index after or at a start index where this buffer contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this buffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

93. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this buffer contains a given sequence as a slice.

    Finds first index where this buffer contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this buffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

94. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this buffer that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      SeqLike → GenSeqLike

95. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this buffer that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

96. #### def indices: collection.immutable.Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this buffer.

    Definition Classes
      SeqLike

97. #### def init: Buffer[A]

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a buffer consisting of all elements of this buffer except the last one.

    Definition Classes
      TraversableLike → GenTraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the buffer is empty.

98. #### def inits: collection.Iterator[Buffer[A]]

    Iterates over the inits of this buffer.

    Iterates over the inits of this buffer. The first value will be this buffer and the final one will be an empty buffer, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this buffer

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

99. #### def insert(n: Int, elems: A*): Unit

    Inserts new elements at a given index into this buffer.

    Inserts new elements at a given index into this buffer.

    n

      the index where new elements are inserted.

    elems

      the traversable collection containing the elements to insert.

    Definition Classes
      BufferLike
    Exceptions thrown
      IndexOutOfBoundsException

      if the index `n` is not in the valid range `0 <= n <= length`.

100. #### def insertAll(n: Int, iter: Iterable[A]): Unit

101. #### def intersect(that: collection.Seq[A]): Buffer[A]

     [use case] Computes the multiset intersection between this buffer and another sequence.

     [use case]

     Computes the multiset intersection between this buffer and another sequence.

     that

       the sequence of elements to intersect with.

     returns

       a new buffer which contains all elements of this buffer which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def intersect[B >: A](that: GenSeq[B]): Buffer[A]

102. #### def isDefinedAt(idx: Int): Boolean

     Tests whether this buffer contains given index.

     Tests whether this buffer contains given index.

     The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

     idx

       the index to test

     returns

       `true` if this buffer contains an element at position `idx`, `false` otherwise.

     Definition Classes
       GenSeqLike

103. #### def isEmpty: Boolean

     Tests whether this buffer is empty.

     Tests whether this buffer is empty.

     returns

       `true` if the buffer contain no elements, `false` otherwise.

     Definition Classes
       SeqLike → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

104. #### final def isInstanceOf[T0]: Boolean

     Test whether the dynamic type of the receiver object is `T0`.

     Test whether the dynamic type of the receiver object is `T0`.

     Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

     returns

       `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

     Definition Classes
       Any

105. #### def isParIterable: Boolean

     Implicit information
       This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

106. #### def isParSeq: Boolean

     Implicit information
       This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

107. #### def isParallel: Boolean

     Implicit information
       This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

108. #### final def isTraversableAgain: Boolean

     Tests whether this buffer can be repeatedly traversed.

     Tests whether this buffer can be repeatedly traversed.

     returns

       `true`

     Definition Classes
       TraversableLike → GenTraversableLike → GenTraversableOnce

109. #### def iterator: Iterator[A]

     Creates a new iterator over all elements contained in this iterable object.

     Creates a new iterator over all elements contained in this iterable object.

     returns

       the new iterator

     Definition Classes
       SingleRefCollection → IterableLike → GenIterableLike

110. #### def last: A

     Selects the last element.

     Selects the last element.

     returns

       The last element of this buffer.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       NoSuchElementException

       If the buffer is empty.

111. #### def lastIndexOf(elem: A, end: Int): Int

     [use case] Finds index of last occurrence of some value in this buffer before or at a given end index.

     [use case]

     Finds index of last occurrence of some value in this buffer before or at a given end index.

     elem

       the element value to search for.

     end

       the end index.

     returns

       the index `<= end` of the last element of this buffer that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike
     Full Signature

     #### def lastIndexOf[B >: A](elem: B, end: Int): Int

112. #### def lastIndexOf(elem: A): Int

     [use case] Finds index of last occurrence of some value in this buffer.

     [use case]

     Finds index of last occurrence of some value in this buffer.

     elem

       the element value to search for.

     returns

       the index of the last element of this buffer that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike
     Full Signature

     #### def lastIndexOf[B >: A](elem: B): Int

113. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

     Finds last index before or at a given end index where this buffer contains a given sequence as a slice.

     Finds last index before or at a given end index where this buffer contains a given sequence as a slice.

     that

       the sequence to test

     end

       the end index

     returns

       the last index `<= end` such that the elements of this buffer starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

114. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

     Finds last index where this buffer contains a given sequence as a slice.

     Finds last index where this buffer contains a given sequence as a slice.

     that

       the sequence to test

     returns

       the last index such that the elements of this buffer starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

     Definition Classes
       SeqLike

115. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

     Finds index of last element satisfying some predicate before or at given end index.

     Finds index of last element satisfying some predicate before or at given end index.

     p

       the predicate used to test elements.

     returns

       the index `<= end` of the last element of this buffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       SeqLike → GenSeqLike

116. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

     Finds index of last element satisfying some predicate.

     Finds index of last element satisfying some predicate.

     p

       the predicate used to test elements.

     returns

       the index of the last element of this buffer that satisfies the predicate `p`, or `-1`, if none exists.

     Definition Classes
       GenSeqLike

117. #### def lastOption: Option[A]

     Optionally selects the last element.

     Optionally selects the last element.

     returns

       the last element of this buffer$ if it is nonempty, `None` if it is empty.

     Definition Classes
       TraversableLike → GenTraversableLike

118. #### def length: Int

     The length of the buffer.

     The length of the buffer.

     Note: `xs.length` and `xs.size` yield the same result.

     returns

       the number of elements in this buffer.

     Definition Classes
       RefBuffer → BufferLike → SeqLike → GenSeqLike

119. #### def lengthCompare(len: Int): Int

     Compares the length of this buffer to a test value.

     Compares the length of this buffer to a test value.

     len

       the test value that gets compared with the length.

     returns

       A value `x` where

           x <  0       if this.length <  len
           x == 0       if this.length == len
           x >  0       if this.length >  len

       The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

     Definition Classes
       SeqLike

120. #### def lift: (Int) ⇒ Option[A]

     Turns this partial function into a plain function returning an `Option` result.

     Turns this partial function into a plain function returning an `Option` result.

     returns

       a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

     Definition Classes
       PartialFunction
     See also

       Function.unlift

121. #### def map[B](f: (A) ⇒ B): Buffer[B]

     [use case] Builds a new collection by applying a function to all elements of this buffer.

     [use case]

     Builds a new collection by applying a function to all elements of this buffer.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new buffer resulting from applying the given function `f` to each element of this buffer and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic
     Full Signature

     #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

122. #### def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def max[B >: A](implicit cmp: Ordering[B]): A

123. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

124. #### def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this buffer

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def min[B >: A](implicit cmp: Ordering[B]): A

125. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

126. #### def mkString: String

     Displays all elements of this buffer in a string.

     Displays all elements of this buffer in a string.

     returns

       a string representation of this buffer. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this buffer follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### def mkString(sep: String): String

     Displays all elements of this buffer in a string using a separator string.

     Displays all elements of this buffer in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this buffer. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this buffer are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

128. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this buffer in a string using start, end, and separator strings.

     Displays all elements of this buffer in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this buffer. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this buffer are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

129. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

130. #### def newBuilder: Builder[A, Buffer[A]]

     The builder that builds instances of type `Buffer`[A]

     The builder that builds instances of type `Buffer`[A]

     Attributes
       protected[this]
     Definition Classes
       GenericTraversableTemplate → HasNewBuilder

131. #### def nonEmpty: Boolean

     Tests whether the buffer is not empty.

     Tests whether the buffer is not empty.

     returns

       `true` if the buffer contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

132. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

133. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

134. #### def orElse[A1 <: Int, B1 >: A](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

135. #### def padTo(len: Int, elem: A): Buffer[A]

     [use case] A copy of this buffer with an element value appended until a given target length is reached.

     [use case]

     A copy of this buffer with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new buffer consisting of all elements of this buffer followed by the minimal number of occurrences of `elem` so that the resulting buffer has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

136. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

137. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → SeqLike → TraversableLike → Parallelizable

138. #### def partition(p: (A) ⇒ Boolean): (Buffer[A], Buffer[A])

     Partitions this buffer in two buffers according to a predicate.

     Partitions this buffer in two buffers according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of buffers: the first buffer consists of all elements that satisfy the predicate `p` and the second buffer consists of all elements that don't. The relative order of the elements in the resulting buffers is the same as in the original buffer.

     Definition Classes
       TraversableLike → GenTraversableLike

139. #### def patch(from: Int, that: GenSeq[A], replaced: Int): Buffer[A]

     [use case] Produces a new buffer where a slice of elements in this buffer is replaced by another sequence.

     [use case]

     Produces a new buffer where a slice of elements in this buffer is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original buffer

     returns

       a new buffer consisting of all elements of this buffer except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

140. #### def permutations: collection.Iterator[Buffer[A]]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this buffer.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

141. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this buffer such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

142. #### def prepend(elems: A*): Unit

     Prepends given elements to this buffer.

     Prepends given elements to this buffer.

     elems

       the elements to prepend.

     Definition Classes
       BufferLike

143. #### def prependAll(xs: collection.TraversableOnce[A]): Unit

     Prepends the elements contained in a traversable object to this buffer.

     Prepends the elements contained in a traversable object to this buffer.

     xs

       the collection containing the elements to prepend.

     Definition Classes
       BufferLike

144. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this buffer of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the buffer and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def product[B >: A](implicit num: Numeric[B]): B

145. #### def purgeReferences(): Unit

     Definition Classes
       SingleRefCollection

146. #### def readOnly: collection.Seq[A]

     Provide a read-only view of this buffer as a sequence

     Provide a read-only view of this buffer as a sequence

     returns

       A sequence which refers to this buffer for all its operations.

     Definition Classes
       BufferLike

147. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this buffer using the specified associative binary operator.

     Reduces the elements of this buffer using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the buffer is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this buffer is empty.

148. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Applies a binary operator to all elements of this buffer, going left to right.

     Applies a binary operator to all elements of this buffer, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this buffer, going left to right:

           op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

       where `x1, ..., xn` are the elements of this buffer.

     Definition Classes
       TraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this buffer is empty.

149. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this buffer, going left to right.

     Optionally applies a binary operator to all elements of this buffer, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this buffer is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

150. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this buffer, if any, using the specified associative binary operator.

     Reduces the elements of this buffer, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

151. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this buffer, going right to left.

     Applies a binary operator to all elements of this buffer, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this buffer, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this buffer.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this buffer is empty.

152. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this buffer, going right to left.

     Optionally applies a binary operator to all elements of this buffer, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this buffer is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

153. #### val referenceQueue: ReferenceQueue[A]

     Attributes
       protected[this]
     Definition Classes
       SingleRefCollection

154. #### def remove(n: Int): A

     Removes the element at a given index from this buffer.

     Removes the element at a given index from this buffer.

     n

       the index which refers to the element to delete.

     returns

       the previous element at index `n`

     Definition Classes
       RefBuffer → BufferLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the if the index `n` is not in the valid range `0 <= n < length`.

155. #### def remove(el: A): Unit

156. #### def remove(n: Int, count: Int): Unit

     Removes a number of elements from a given index position.

     Removes a number of elements from a given index position.

     n

       the index which refers to the first element to remove.

     count

       the number of elements to remove.

     Definition Classes
       BufferLike
     Exceptions thrown
       IllegalArgumentException

       if `count < 0`.

       IndexOutOfBoundsException

       if the index `n` is not in the valid range `0 <= n <= length - count`.

157. #### def removeReference(ref: Reference[A]): Unit

     Attributes
       protected[this]
     Definition Classes
       RefBuffer → SingleRefCollection

158. #### def repr: Buffer[A]

     The collection of type buffer underlying this `TraversableLike` object.

     The collection of type buffer underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

159. #### def reverse: Buffer[A]

     Returns new buffer wih elements in reversed order.

     Returns new buffer wih elements in reversed order.

     returns

       A new buffer with all elements of this buffer in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

160. #### def reverseIterator: collection.Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this buffer in reversed order

     Definition Classes
       SeqLike

161. #### def reverseMap[B](f: (A) ⇒ B): Buffer[B]

     [use case] Builds a new collection by applying a function to all elements of this buffer and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this buffer and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new buffer resulting from applying the given function `f` to each element of this buffer and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

162. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

163. #### def runWith[U](action: (A) ⇒ U): (Int) ⇒ Boolean

     Composes this partial function with an action function which gets applied to results of this partial function.

     Composes this partial function with an action function which gets applied to results of this partial function. The action function is invoked only for its side effects; its result is ignored.

     Note that expression `pf.runWith(action)(x)` is equivalent to

         if(pf isDefinedAt x) { action(pf(x)); true } else false

     except that `runWith` is implemented via `applyOrElse` and thus potentially more efficient. Using `runWith` avoids double evaluation of pattern matchers and guards for partial function literals.

     action

       the action function

     returns

       a function which maps arguments `x` to `isDefinedAt(x)`. The resulting function runs `action(this(x))` where `this` is defined.

     Definition Classes
       PartialFunction
     Since

       2.10

     See also

       `applyOrElse`.

164. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this buffer.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this buffer.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def sameElements[B >: A](that: GenIterable[B]): Boolean

165. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Buffer[A], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new buffer containing the prefix scan of the elements in this buffer

     Definition Classes
       TraversableLike → GenTraversableLike

166. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

167. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

168. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this buffer starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       SeqLike → GenSeqLike

169. #### def seq: collection.mutable.Seq[A]

     A version of this collection with all of the operations implemented sequentially (i.

     A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Seq → Seq → GenSeq → GenSeqLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

170. #### def size: Int

     The size of this buffer, equivalent to `length`.

     The size of this buffer, equivalent to `length`.

     returns

       the number of elements in this buffer.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

171. #### def slice(from: Int, until: Int): Buffer[A]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     returns

       a buffer containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this buffer.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

172. #### def sliding(size: Int, step: Int): collection.Iterator[Buffer[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups (defaults to 1)

     returns

       An iterator producing buffers of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

173. #### def sliding(size: Int): collection.Iterator[Buffer[A]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing buffers of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

174. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: math.Ordering[B]): Buffer[A]

     Sorts this `Buffer` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this `Buffer` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a buffer consisting of the elements of this buffer sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.     val words = "The quick brown fox jumped over the lazy dog".split(' ')
            // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
            words.sortBy(x => (x.length, x.head))
            res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

175. #### def sortWith(lt: (A, A) ⇒ Boolean): Buffer[A]

     Sorts this buffer according to a comparison function.

     Sorts this buffer according to a comparison function.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a buffer consisting of the elements of this buffer sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.     List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
            List("Bob", "John", "Steve", "Tom")

176. #### def sorted[B >: A](implicit ord: math.Ordering[B]): Buffer[A]

     Sorts this buffer according to an Ordering.

     Sorts this buffer according to an Ordering.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a buffer consisting of the elements of this buffer sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

177. #### def span(p: (A) ⇒ Boolean): (Buffer[A], Buffer[A])

     Splits this buffer into a prefix/suffix pair according to a predicate.

     Splits this buffer into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     returns

       a pair consisting of the longest prefix of this buffer whose elements all satisfy `p`, and the rest of this buffer.

     Definition Classes
       TraversableLike → GenTraversableLike

178. #### def splitAt(n: Int): (Buffer[A], Buffer[A])

     Splits this buffer into two at a given position.

     Splits this buffer into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of buffers consisting of the first `n` elements of this buffer, and the other elements.

     Definition Classes
       TraversableLike → GenTraversableLike

179. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this buffer contains the given sequence at a given index.

     Tests whether this buffer contains the given sequence at a given index.

     Note: If the both the receiver object `this` and the argument `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this buffer at index `offset`, otherwise `false`.

     Definition Classes
       SeqLike → GenSeqLike

180. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this buffer starts with the given sequence.

     Tests whether this buffer starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

181. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this set. Unless overridden this is simply `"Buffer"`.

     Definition Classes
       BufferLike → TraversableLike → GenTraversableLike

182. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this buffer of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the buffer and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: A](implicit num: Numeric[B]): B

183. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

184. #### def tail: Buffer[A]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a buffer consisting of all elements of this buffer except the first one.

     Definition Classes
       TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the buffer is empty.

185. #### def tails: collection.Iterator[Buffer[A]]

     Iterates over the tails of this buffer.

     Iterates over the tails of this buffer. The first value will be this buffer and the final one will be an empty buffer, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this buffer

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

186. #### def take(n: Int): Buffer[A]

     Selects first n elements.

     Selects first n elements.

     n

       the number of elements to take from this buffer.

     returns

       a buffer consisting only of the first `n` elements of this buffer, or else the whole buffer, if it has less than `n` elements.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

187. #### def takeRight(n: Int): Buffer[A]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a buffer consisting only of the last `n` elements of this buffer, or else the whole buffer, if it has less than `n` elements.

     Definition Classes
       IterableLike

188. #### def takeWhile(p: (A) ⇒ Boolean): Buffer[A]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     returns

       the longest prefix of this buffer whose elements all satisfy the predicate `p`.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableLike

189. #### def thisCollection: collection.Seq[A]

     The underlying collection seen as an instance of ``Buffer``.

     The underlying collection seen as an instance of ``Buffer``. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

190. #### def to[Col[_]]: Col[A]

     [use case] Converts this buffer into another by copying all elements.

     [use case]

     Converts this buffer into another by copying all elements.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this buffer.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, A, Col[A]]): Col[A]

191. #### def toArray: Array[A]

     [use case] Converts this buffer to an array.

     [use case]

     Converts this buffer to an array.

     returns

       an array containing all elements of this buffer. An `ClassTag` must be available for the element type of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: A](implicit arg0: ClassTag[B]): Array[B]

192. #### def toBuffer[B >: A]: Buffer[B]

     Converts this buffer to a mutable buffer.

     Converts this buffer to a mutable buffer.

     returns

       a buffer containing all elements of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

193. #### def toCollection(repr: Buffer[A]): collection.Seq[A]

     A conversion from collections of type `Repr` to ``Buffer`` objects.

     A conversion from collections of type `Repr` to ``Buffer`` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       SeqLike → IterableLike → TraversableLike

194. #### def toIndexedSeq: collection.immutable.IndexedSeq[A]

     Converts this buffer to an indexed sequence.

     Converts this buffer to an indexed sequence.

     returns

       an indexed sequence containing all elements of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

195. #### def toIterable: collection.Iterable[A]

     Converts this buffer to an iterable collection.

     Converts this buffer to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this buffer.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

196. #### def toIterator: collection.Iterator[A]

     Returns an Iterator over the elements in this buffer.

     Returns an Iterator over the elements in this buffer. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this buffer.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

197. #### def toList: List[A]

     Converts this buffer to a list.

     Converts this buffer to a list.

     returns

       a list containing all elements of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

198. #### def toMap[T, U]: Map[T, U]

     [use case] Converts this buffer to a map.

     [use case]

     Converts this buffer to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

199. #### def toParArray: ParArray[A]

     Implicit information
       This member is added by an implicit conversion from RefBuffer[A] to TraversableOps[A] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

200. #### def toSeq: collection.Seq[A]

     Converts this buffer to a sequence.

     Converts this buffer to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this buffer.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

201. #### def toSet[B >: A]: Set[B]

     Converts this buffer to a set.

     Converts this buffer to a set.

     returns

       a set containing all elements of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

202. #### def toStream: collection.immutable.Stream[A]

     Converts this buffer to a stream.

     Converts this buffer to a stream.

     returns

       a stream containing all elements of this buffer.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

203. #### def toString(): String

     Converts this buffer to a string.

     Converts this buffer to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this buffer, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → Any

204. #### def toTraversable: collection.Traversable[A]

     Converts this buffer to an unspecified Traversable.

     Converts this buffer to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this buffer.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

205. #### def toVector: Vector[A]

     Converts this buffer to a Vector.

     Converts this buffer to a Vector.

     returns

       a vector containing all elements of this buffer.

     Definition Classes
       TraversableOnce → GenTraversableOnce

206. #### def transform(f: (A) ⇒ A): RefBuffer.this.type

     Applies a transformation function to all values contained in this sequence.

     Applies a transformation function to all values contained in this sequence. The transformation function produces new values from existing elements.

     f

       the transformation to apply

     returns

       the sequence itself.

     Definition Classes
       SeqLike

207. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): Buffer[Buffer[B]]

     Transposes this buffer of traversable collections into a buffer of buffers.

     Transposes this buffer of traversable collections into a buffer of buffers.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this buffer is a `Traversable`.

     returns

       a two-dimensional buffer of buffers which has as nth row the nth column of this buffer.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this buffer are not of the same size.

208. #### def trimEnd(n: Int): Unit

     Removes the last n elements of this buffer.

     Removes the last n elements of this buffer.

     n

       the number of elements to remove from the end of this buffer.

     Definition Classes
       BufferLike

209. #### def trimStart(n: Int): Unit

     Removes the first n elements of this buffer.

     Removes the first n elements of this buffer.

     n

       the number of elements to remove from the beginning of this buffer.

     Definition Classes
       BufferLike

210. #### def union(that: collection.Seq[A]): Buffer[A]

     [use case] Produces a new sequence which contains all elements of this buffer and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this buffer and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     that

       the sequence to add.

     returns

       a new buffer which contains all elements of this buffer followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

211. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (Buffer[A1], Buffer[A2])

     Converts this buffer of pairs into two collections of the first and second half of each pair.

     Converts this buffer of pairs into two collections of the first and second half of each pair.

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this buffer is a pair.

     returns

       a pair buffers, containing the first, respectively second half of each element pair of this buffer.

     Definition Classes
       GenericTraversableTemplate

212. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (Buffer[A1], Buffer[A2], Buffer[A3])

     Converts this buffer of triples into three collections of the first, second, and third element of each triple.

     Converts this buffer of triples into three collections of the first, second, and third element of each triple.

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this buffer is a triple.

     returns

       a triple buffers, containing the first, second, respectively third member of each element triple of this buffer.

     Definition Classes
       GenericTraversableTemplate

213. #### def update(n: Int, el: A): Unit

     Replaces element at given index with a new value.

     Replaces element at given index with a new value.

     Definition Classes
       RefBuffer → BufferLike → SeqLike
     Exceptions thrown
       IndexOutOfBoundsException

       if the index is not valid.

214. #### def updated(index: Int, elem: A): Buffer[A]

     [use case] A copy of this buffer with one single replaced element.

     [use case]

     A copy of this buffer with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a copy of this buffer with the element at position `index` replaced by `elem`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[Buffer[A], B, That]): That

215. #### def view(from: Int, until: Int): SeqView[A, Buffer[A]]

     Creates a non-strict view of a slice of this buffer.

     Creates a non-strict view of a slice of this buffer.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current buffer, whereas `slice` produces a new buffer.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this buffer, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

216. #### def view: SeqView[A, Buffer[A]]

     Creates a non-strict view of this buffer.

     Creates a non-strict view of this buffer.

     returns

       a non-strict view of this buffer.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

217. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

218. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

219. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

220. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, Buffer[A]]

     Creates a non-strict filter of this buffer.

     Creates a non-strict filter of this buffer.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this buffer which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

221. #### def zip[B](that: GenIterable[B]): Buffer[(A, B)]

     [use case] Returns a buffer formed from this buffer and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a buffer formed from this buffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new buffer containing pairs consisting of corresponding elements of this buffer and `that`. The length of the returned collection is the minimum of the lengths of this buffer and `that`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Buffer[A], (A1, B), That]): That

222. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): Buffer[(A, B)]

     [use case] Returns a buffer formed from this buffer and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a buffer formed from this buffer and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this buffer is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this buffer.

     returns

       a new buffer containing pairs consisting of corresponding elements of this buffer and `that`. The length of the returned collection is the maximum of the lengths of this buffer and `that`. If this buffer is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this buffer, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Buffer[A], (A1, B), That]): That

223. #### def zipWithIndex: Buffer[(A, Int)]

     [use case] Zips this buffer with its indices.

     [use case]

     Zips this buffer with its indices.

     returns

       A new buffer containing pairs consisting of all elements of this buffer paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[Buffer[A], (A1, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

224. #### def →[B](y: B): (RefBuffer[A], B)

     Implicit information
       This member is added by an implicit conversion from RefBuffer[A] to ArrowAssoc[RefBuffer[A]] performed by method any2ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def filter(p: (A) ⇒ Boolean): collection.TraversableOnce[A]

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (refBuffer: MonadOps[A]).filter(p)

   Definition Classes
     MonadOps

2. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): collection.TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (refBuffer: MonadOps[A]).flatMap(f)

   Definition Classes
     MonadOps

3. #### def map[B](f: (A) ⇒ B): collection.TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (refBuffer: MonadOps[A]).map(f)

   Definition Classes
     MonadOps

4. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (refBuffer: StringAdd).self

   Definition Classes
     StringAdd

5. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (refBuffer: StringFormat).self

   Definition Classes
     StringFormat

6. #### def withFilter(p: (A) ⇒ Boolean): collection.Iterator[A]

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to MonadOps[A] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (refBuffer: MonadOps[A]).withFilter(p)

   Definition Classes
     MonadOps

### Deprecated Value Members

1. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (a /:\ 5)(_+_)
       b: Int = 15

   Definition Classes
     GenTraversableOnce
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use fold instead

2. #### def x: RefBuffer[A]

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to ArrowAssoc[RefBuffer[A]] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (refBuffer: ArrowAssoc[RefBuffer[A]]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

3. #### def x: RefBuffer[A]

   Implicit information
     This member is added by an implicit conversion from RefBuffer[A] to Ensuring[RefBuffer[A]] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (refBuffer: Ensuring[RefBuffer[A]]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from SingleRefCollection[A]

### Inherited from Buffer[A]

### Inherited from BufferLike[A, Buffer[A]]

### Inherited from Subtractable[A, Buffer[A]]

### Inherited from Scriptable[A]

### Inherited from Shrinkable[A]

### Inherited from Growable[A]

### Inherited from Clearable

### Inherited from collection.mutable.Seq[A]

### Inherited from SeqLike[A, Buffer[A]]

### Inherited from collection.mutable.Cloneable[Buffer[A]]

### Inherited from Cloneable

### Inherited from java.lang.Cloneable

### Inherited from collection.Seq[A]

### Inherited from SeqLike[A, Buffer[A]]

### Inherited from GenSeq[A]

### Inherited from GenSeqLike[A, Buffer[A]]

### Inherited from PartialFunction[Int, A]

### Inherited from (Int) ⇒ A

### Inherited from collection.mutable.Iterable[A]

### Inherited from collection.Iterable[A]

### Inherited from IterableLike[A, Buffer[A]]

### Inherited from Equals

### Inherited from GenIterable[A]

### Inherited from GenIterableLike[A, Buffer[A]]

### Inherited from collection.mutable.Traversable[A]

### Inherited from Mutable

### Inherited from collection.Traversable[A]

### Inherited from GenTraversable[A]

### Inherited from GenericTraversableTemplate[A, Buffer]

### Inherited from TraversableLike[A, Buffer[A]]

### Inherited from GenTraversableLike[A, Buffer[A]]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from collection.TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, Buffer[A]]

### Inherited from HasNewBuilder[A, scala.collection.mutable.Buffer[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion traversable2ops from RefBuffer[A] to TraversableOps[A]

### Inherited by implicit conversion MonadOps from RefBuffer[A] to MonadOps[A]

### Inherited by implicit conversion any2stringadd from RefBuffer[A] to StringAdd

### Inherited by implicit conversion any2stringfmt from RefBuffer[A] to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from RefBuffer[A] to ArrowAssoc[RefBuffer[A]]

### Inherited by implicit conversion any2Ensuring from RefBuffer[A] to Ensuring[RefBuffer[A]]

### Inherited by implicit conversion alternateImplicit from RefBuffer[A] to ForceImplicitAmbiguity

### Ungrouped